// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	oauthv1 "github.com/openshift/api/oauth/v1"
	internal "github.com/openshift/client-go/oauth/applyconfigurations/internal"
	apismetav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	metav1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// UserOAuthAccessTokenApplyConfiguration represents a declarative configuration of the UserOAuthAccessToken type for use
// with apply.
type UserOAuthAccessTokenApplyConfiguration struct {
	metav1.TypeMetaApplyConfiguration    `json:",inline"`
	*metav1.ObjectMetaApplyConfiguration `json:"metadata,omitempty"`
	ClientName                           *string  `json:"clientName,omitempty"`
	ExpiresIn                            *int64   `json:"expiresIn,omitempty"`
	Scopes                               []string `json:"scopes,omitempty"`
	RedirectURI                          *string  `json:"redirectURI,omitempty"`
	UserName                             *string  `json:"userName,omitempty"`
	UserUID                              *string  `json:"userUID,omitempty"`
	AuthorizeToken                       *string  `json:"authorizeToken,omitempty"`
	RefreshToken                         *string  `json:"refreshToken,omitempty"`
	InactivityTimeoutSeconds             *int32   `json:"inactivityTimeoutSeconds,omitempty"`
}

// UserOAuthAccessToken constructs a declarative configuration of the UserOAuthAccessToken type for use with
// apply.
func UserOAuthAccessToken(name string) *UserOAuthAccessTokenApplyConfiguration {
	b := &UserOAuthAccessTokenApplyConfiguration{}
	b.WithName(name)
	b.WithKind("UserOAuthAccessToken")
	b.WithAPIVersion("oauth.openshift.io/v1")
	return b
}

// ExtractUserOAuthAccessToken extracts the applied configuration owned by fieldManager from
// userOAuthAccessToken. If no managedFields are found in userOAuthAccessToken for fieldManager, a
// UserOAuthAccessTokenApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// userOAuthAccessToken must be a unmodified UserOAuthAccessToken API object that was retrieved from the Kubernetes API.
// ExtractUserOAuthAccessToken provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractUserOAuthAccessToken(userOAuthAccessToken *oauthv1.UserOAuthAccessToken, fieldManager string) (*UserOAuthAccessTokenApplyConfiguration, error) {
	return extractUserOAuthAccessToken(userOAuthAccessToken, fieldManager, "")
}

// ExtractUserOAuthAccessTokenStatus is the same as ExtractUserOAuthAccessToken except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractUserOAuthAccessTokenStatus(userOAuthAccessToken *oauthv1.UserOAuthAccessToken, fieldManager string) (*UserOAuthAccessTokenApplyConfiguration, error) {
	return extractUserOAuthAccessToken(userOAuthAccessToken, fieldManager, "status")
}

func extractUserOAuthAccessToken(userOAuthAccessToken *oauthv1.UserOAuthAccessToken, fieldManager string, subresource string) (*UserOAuthAccessTokenApplyConfiguration, error) {
	b := &UserOAuthAccessTokenApplyConfiguration{}
	err := managedfields.ExtractInto(userOAuthAccessToken, internal.Parser().Type("com.github.openshift.api.oauth.v1.UserOAuthAccessToken"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}
	b.WithName(userOAuthAccessToken.Name)

	b.WithKind("UserOAuthAccessToken")
	b.WithAPIVersion("oauth.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithKind(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.TypeMetaApplyConfiguration.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithAPIVersion(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.TypeMetaApplyConfiguration.APIVersion = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithName(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.Name = &value
	return b
}

// WithGenerateName sets the GenerateName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GenerateName field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithGenerateName(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.GenerateName = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithNamespace(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.Namespace = &value
	return b
}

// WithUID sets the UID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UID field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithUID(value types.UID) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.UID = &value
	return b
}

// WithResourceVersion sets the ResourceVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceVersion field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithResourceVersion(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.ResourceVersion = &value
	return b
}

// WithGeneration sets the Generation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Generation field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithGeneration(value int64) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.Generation = &value
	return b
}

// WithCreationTimestamp sets the CreationTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CreationTimestamp field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithCreationTimestamp(value apismetav1.Time) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.CreationTimestamp = &value
	return b
}

// WithDeletionTimestamp sets the DeletionTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionTimestamp field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithDeletionTimestamp(value apismetav1.Time) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.DeletionTimestamp = &value
	return b
}

// WithDeletionGracePeriodSeconds sets the DeletionGracePeriodSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionGracePeriodSeconds field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithDeletionGracePeriodSeconds(value int64) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ObjectMetaApplyConfiguration.DeletionGracePeriodSeconds = &value
	return b
}

// WithLabels puts the entries into the Labels field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Labels field,
// overwriting an existing map entries in Labels field with the same key.
func (b *UserOAuthAccessTokenApplyConfiguration) WithLabels(entries map[string]string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.ObjectMetaApplyConfiguration.Labels == nil && len(entries) > 0 {
		b.ObjectMetaApplyConfiguration.Labels = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.ObjectMetaApplyConfiguration.Labels[k] = v
	}
	return b
}

// WithAnnotations puts the entries into the Annotations field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Annotations field,
// overwriting an existing map entries in Annotations field with the same key.
func (b *UserOAuthAccessTokenApplyConfiguration) WithAnnotations(entries map[string]string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.ObjectMetaApplyConfiguration.Annotations == nil && len(entries) > 0 {
		b.ObjectMetaApplyConfiguration.Annotations = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.ObjectMetaApplyConfiguration.Annotations[k] = v
	}
	return b
}

// WithOwnerReferences adds the given value to the OwnerReferences field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the OwnerReferences field.
func (b *UserOAuthAccessTokenApplyConfiguration) WithOwnerReferences(values ...*metav1.OwnerReferenceApplyConfiguration) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithOwnerReferences")
		}
		b.ObjectMetaApplyConfiguration.OwnerReferences = append(b.ObjectMetaApplyConfiguration.OwnerReferences, *values[i])
	}
	return b
}

// WithFinalizers adds the given value to the Finalizers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Finalizers field.
func (b *UserOAuthAccessTokenApplyConfiguration) WithFinalizers(values ...string) *UserOAuthAccessTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		b.ObjectMetaApplyConfiguration.Finalizers = append(b.ObjectMetaApplyConfiguration.Finalizers, values[i])
	}
	return b
}

func (b *UserOAuthAccessTokenApplyConfiguration) ensureObjectMetaApplyConfigurationExists() {
	if b.ObjectMetaApplyConfiguration == nil {
		b.ObjectMetaApplyConfiguration = &metav1.ObjectMetaApplyConfiguration{}
	}
}

// WithClientName sets the ClientName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ClientName field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithClientName(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.ClientName = &value
	return b
}

// WithExpiresIn sets the ExpiresIn field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ExpiresIn field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithExpiresIn(value int64) *UserOAuthAccessTokenApplyConfiguration {
	b.ExpiresIn = &value
	return b
}

// WithScopes adds the given value to the Scopes field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Scopes field.
func (b *UserOAuthAccessTokenApplyConfiguration) WithScopes(values ...string) *UserOAuthAccessTokenApplyConfiguration {
	for i := range values {
		b.Scopes = append(b.Scopes, values[i])
	}
	return b
}

// WithRedirectURI sets the RedirectURI field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the RedirectURI field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithRedirectURI(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.RedirectURI = &value
	return b
}

// WithUserName sets the UserName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UserName field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithUserName(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.UserName = &value
	return b
}

// WithUserUID sets the UserUID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UserUID field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithUserUID(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.UserUID = &value
	return b
}

// WithAuthorizeToken sets the AuthorizeToken field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the AuthorizeToken field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithAuthorizeToken(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.AuthorizeToken = &value
	return b
}

// WithRefreshToken sets the RefreshToken field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the RefreshToken field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithRefreshToken(value string) *UserOAuthAccessTokenApplyConfiguration {
	b.RefreshToken = &value
	return b
}

// WithInactivityTimeoutSeconds sets the InactivityTimeoutSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the InactivityTimeoutSeconds field is set to the value of the last call.
func (b *UserOAuthAccessTokenApplyConfiguration) WithInactivityTimeoutSeconds(value int32) *UserOAuthAccessTokenApplyConfiguration {
	b.InactivityTimeoutSeconds = &value
	return b
}

// GetName retrieves the value of the Name field in the declarative configuration.
func (b *UserOAuthAccessTokenApplyConfiguration) GetName() *string {
	b.ensureObjectMetaApplyConfigurationExists()
	return b.ObjectMetaApplyConfiguration.Name
}
